﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Visualising_Graphs
{
    internal class Program
    {
        static void Main(string[] args)
        {
            Graphs();
            End();
        }

        public static int Graphs()
        {
            // list to store x and y values
            List<int> xValues = new List<int> { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
            List<int> yValues = new List<int> { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};

            
            // Length of how many x-values there are (this will become width of the graph)
            int plotLength = xValues.Count;
            int yPoint = xValues[0];

            // Length of how many y-values there are (this will become height of the graph)
            int plotHeight = yValues.Count;
            int xPoint = yValues[0];

            // Variables for the height and width of the graph
            int graphHeight = plotHeight;
            int graphWidth = plotLength;

            // Gets the centre of the graph
            int centre = graphHeight / 2;


            //y-axis
            for (int y = 0; y <= graphHeight; y++)
            {
                Console.SetCursorPosition(5, y);
                if (y == centre)
                {
                    Console.Write(" 0+"); // midpoint is always 0 and where the x-axis is
                }
                else if (y < graphHeight / 2)
                {
                    Console.Write($" {centre - y}|");
                }
                else if (y > graphHeight / 2)
                {
                    Console.Write($"{centre - y}|");
                }

                

                // p (plotting point) will allow for (X) to be marked along the x-axis at the correct height accordingly
                for (int p = 0; p <= plotLength; p++)
                {
                    if (y == yPoint + 1)
                    {
                        Console.Write("X"); // Draws the 'X' points horizontally at y=2
                    }
                }
            }

            //x-axis
            for (int x = 0; x <= graphWidth; x++)
            {
                Console.SetCursorPosition(x + 8, centre); // x-axis lies on the midpoint as graphs can go negative
                Console.WriteLine("-");

                

                // p (plotting point) will allow for (X) to be marked along the y-axis at the correct x-point accordingly
                if (x == xPoint)
                {
                    for (int p = 0; p <= plotHeight; p++)
                    {
                        Console.SetCursorPosition(x + 8, graphHeight - p);
                        Console.WriteLine("X");
                    }
                }
                
            }


            return graphHeight;
        }

        /// <summary>
        /// Ensures the console does not close immediately after creating the grapp
        /// wait for user input to close
        /// place the message directly below the graph
        /// </summary>
        public static void End()
        {
            int height = Graphs();

            Console.SetCursorPosition(0, height);
            Console.WriteLine("Press ENTER to exit....");
            Console.ReadLine();
        }
    }
}
